#!/usr/bin/python
# This Python file uses the following encoding: utf-8
import yaml
from dateutil.parser import parse
import datetime
import dateutil.tz as tz
import sys
import os
import os.path
import subprocess
import settings
from mako.template import Template

config=settings.load_settings()

HERE  = os.path.dirname(__file__)

def render_template(path, date, **kwargs):
    with open('out/report.yml') as r:
        report = yaml.safe_load(r)

    with open('bloggers.yml') as f:
        users = yaml.safe_load(f)

    posts = report.setdefault(date, [])

    if len(date)>0 and len(posts)==0:
        return ""

    return Template(filename=path, output_encoding='utf-8').render(
       users=users, posts=posts, date=date,
        **kwargs)

if __name__ == '__main__':
    if len(sys.argv) < 2:
        print >>sys.stderr, "Usage: %s TEMPLATE [WEEK]"
        sys.exit(1)

    template = sys.argv[1]
    week = None
    if len(sys.argv) > 2: week = sys.argv[2]
    print render_template(template, week)
